"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.readConfig = void 0;
const tslib_1 = require("tslib");
const cosmiconfig_1 = require("cosmiconfig");
const cosmiconfig_typescript_loader_1 = require("cosmiconfig-typescript-loader");
const readConfig = (_a) => tslib_1.__awaiter(void 0, [_a], void 0, function* ({ fileName, filePath, fallbackName, }) {
    var _b, _c;
    try {
        let _fileName_ = fileName;
        if (!_fileName_ && !filePath) {
            _fileName_ = fallbackName;
        }
        const explorerSync = (0, cosmiconfig_1.cosmiconfigSync)(_fileName_ || fallbackName, {
            loaders: {
                '.ts': (0, cosmiconfig_typescript_loader_1.TypeScriptLoader)(),
            },
        });
        if (!_fileName_) {
            return (yield ((_b = explorerSync.load(filePath)) === null || _b === void 0 ? void 0 : _b.config));
        }
        else {
            return (yield ((_c = explorerSync.search()) === null || _c === void 0 ? void 0 : _c.config));
        }
    }
    catch (error) {
        return undefined;
    }
});
exports.readConfig = readConfig;
